// Creative Technology, Module 2: Smart Environments
// Final Project, Team O
// Code by Zino J. Vieth
// "tbd"-Application (for Android)
//
// Functions:   Finding the HUB using UDP beacons and connecting to it via TCP.
//              Receiving and displaying information about the greenhouse modules from the HUB.
//              Sending User Input to the HUB.
//
// Program Main Class "AndroidApp"
// Runs User Interface and process Threads.++
//  - Controller
//      - ServerFinder
//      - TCPClient

// Global Variables
    static long ms;

    final int SEARCHSCREEN = 0;
    final int MAINSCREEN = 1;

// Global Objects
Controller controller;
GraphicUserInterface gui;
ModuleChanger moduleChanger;

// ----- Program Setup -----
void setup()
{
    //size(412, 847);
    fullScreen();
        ellipseMode ( CENTER );
        imageMode   ( CENTER );
        rectMode    ( CENTER );
        textAlign   ( CENTER, CENTER );
        shapeMode   ( CENTER );

    gui = new GraphicUserInterface();
    gui.loadScreens();
    moduleChanger = new ModuleChanger();

    // Setup File Reader
        new FileReader( this );

    // Attempt Initial TCP Connection
        //Controller.connectToTCP( Controller.getHubIP() );

    // Start Controller Thread
        controller = new Controller();
        controller.start();


    println( "Main: Program Setup complete. Application running." );
}

// ----- Main Loop -----
void draw()
{
    SYS_update();
    //Controller.updateTCP( true );

    gui.update();
    gui.render();
    if ( moduleChanger.isActive() )
        moduleChanger.display();
}

void SYS_update()
{
    ms = millis();
}

// ----- Event Handling -----
void mousePressed()
{
    float mx = mouseX, my = mouseY;

    // if ( gui.screens[SEARCHSCREEN].helpPopup.isOpen() ) gui.screens[SEARCHSCREEN].helpPopup.hide();
    // if ( gui.screens[SEARCHSCREEN].iButton.hovered() ) gui.screens[SEARCHSCREEN].helpPopup.show();

    if ( gui.screens[ MAINSCREEN ].isActive() )
    {
        if ( moduleChanger.isActive() )
        {
            if ( moduleChanger.clickedOutside( mx, my ) )
                moduleChanger.hide();

            if ( moduleChanger.ledButton.buttonClicked( mx, my ) )
            {
                moduleChanger.ledButton.updateButtonState();
                moduleChanger.changeLedPowerState();
            }

            if ( moduleChanger.wateringButton.buttonClicked( mx, my ) )
            {
                moduleChanger.ledButton.updateButtonState();
                moduleChanger.waterModule();
            }
        }
        else
        {
            ModuleList.Module m = null;
            if ( (m = moduleChanger.boxClicked( mx, my )) != null )
            {
                moduleChanger.show( m );
            }
        }
    }
}
