// Creative Technology, Module 2: Smart Environments
// Final Project, Team O
// Code by Zino J. Vieth
// "tbd"-Application (for Android)
//
// "ConfigReader"-Class (public)
// Reads the HUB IP from connection.conf and passes it to the Controller.
//  readIP     :   reads IP fro .conf file and returns it     :   called by Controller.getHubIP() in TCPClient.Constructor()
//
// ----- Imported Libraries -----
    import java.util.Properties;
    import java.io.*;

public class ConfigReader
{
    // ----- connection.conf Reading Method -----
    public String readIP()
    {
        // Initialize Variables
            String configFilePath = "connection.conf";
            Properties property = new Properties();
            InputStream is = null;


        try {
            System.out.println( "ConfigReader: Attempting to read HUB IP from " + configFilePath );

            // Read connection.cong to file stream
                is = AndroidApp.FileReader.loadFile( configFilePath );

            // Load Properties Object from file stream
                property.load( is );

            // Define Property Key
                String propKey = "hubIP";

            // Retrieve IP Value
                String propValue = property.getProperty( propKey );

            System.out.println( "ConfigReader: The following IP has been read from connection.conf: " + propValue );

            // Pass IP Value
                return propValue;

        } catch ( FileNotFoundException e) {
            System.out.println( "ConfigReader: Config File has not been found." );
            System.out.println( e.getMessage());
        }  catch ( IOException e ) {
            System.out.println( "ConfigReader: Property Object could not be loaded." );
            System.out.println( e.getMessage());
        } catch ( NullPointerException e ) {
            System.out.println( "ConfigReader: Config File has not been loaded correctly." );
            System.out.println( e.getMessage() );
        }

        return null;
    }
}
