// Creative Technology, Module 2: Smart Environments
// Final Project, Team O
// Code by Zino J. Vieth
// "tbd"-Application (for Android)
//
// "ConfigWriter"-Class (public)
// Updates "connection.conf" with the passed IP address of the HUB.
//  Constructor     :   acts as main process of the class   :   called by Controller.passHubIP() in HubFinder.run()->listen()
//
// ----- Imported Libraries -----
    import java.util.Properties;
    import java.io.*;

public class ConfigWriter
{

    // ----- Constructor -----
    // Updates "connection.conf" by the passed HUB IP
    public ConfigWriter(String initIP)
    {
        // Initialize Variables
            String configFilePath = "connection.conf";
            Properties property = new Properties();
            InputStream is = null;

        try {
            System.out.println( "ConfigWriter: Attempting to update " + configFilePath );

            // Opens "connection.conf" into file stream
                is = AndroidApp.FileReader.loadFile( configFilePath );

            // Load Properties Object from file stream
                property.load( is );

            // Define new Property
                String propKey = "hubIP";
                String propValue = initIP;

            // Set Property Value
                property.setProperty( propKey, propValue );
    
            // Save "connection.conf"
                property.store( new FileOutputStream(configFilePath), null );

            System.out.println( "ConfigWriter: Successfully updated " + configFilePath + "." );
        } catch ( FileNotFoundException e) {
            System.out.println( "ConfigWriter: Config File has not been found." );
            System.out.println( e.getMessage());
        } catch ( IOException e ) {
            System.out.println( "ConfigWriter: An error occured while loading or storing properties." );
            System.out.println( e.getMessage());
        }
    }

}
