

// ----- Imported Libraries -----
    import java.util.ArrayList;

public class ModuleList
{

    static final int[][] MODULE_TYPE_PRESET = {
    //    LED ON    LED OFF     Humidity 
        { 3*60,     21*60,      450 },      // Type 0: Garden Cress
        { 1*60,     8*60,       400 },      // Type 1: Champignons
        { 10*60,    14*60,      450 },      // Type 2: Strawberries
        { 14*60,    10*60,      450 },      // Type 3: Lettuce
        { 14*60,    10*60,      450 }       // Type 4: Radishes
    };
    static final int MODULE_TYPE_COUNT = MODULE_TYPE_PRESET.length;

    // SENSOR IDs
    static final int SENSOR_COUNT = 2;
    static final int SENSOR_ID_HUMIDITY = 0;
    static final int SENSOR_ID_WATER_TANK = 1;

    static ModuleList ml = new ModuleList();
    static ArrayList<Module> modules = new ArrayList<Module>();

    public class Module
    {
        // General Fields
            long id;
            int type;
            int[] sensorData;
            int ledPowerOn, ledCycleState;
            long lastCall;

        public Module( long initID, int initType )
        {
            this.id = initID;
            this.type = initType;
            this.sensorData = new int[ SENSOR_COUNT ];
        }

        public int[] getData()
        {
            int[] out = new int[4];
            out[0] = this.sensorData[ SENSOR_ID_HUMIDITY ];
            out[1] = this.sensorData[ SENSOR_ID_WATER_TANK ];
            out[2] = this.ledPowerOn;
            out[3] = this.ledCycleState;

            return out;
        }

        public int getType()
        {
            return this.type;
        }
    }

    static void updateModuleData( long id, int type, int ledPowerOn, int ledCycleState, int humiditySensorValue, int waterTankSensorValue )
    {
        ArrayList<Module> toBeRemoved = new ArrayList<Module>();
        boolean isNewModule = true;
        for ( Module m : modules )
        {
            if ( m.id == id )
            {
                isNewModule = false;
                m.type = type;
                m.ledPowerOn = ledPowerOn;
                m.ledCycleState = ledCycleState;
                m.sensorData[ SENSOR_ID_HUMIDITY ] = humiditySensorValue;
                m.sensorData[ SENSOR_ID_WATER_TANK ] = waterTankSensorValue;
                m.lastCall = AndroidApp.ms;
            }
            if ( AndroidApp.ms - m.lastCall >= 5000 )
                toBeRemoved.add( m );
        }
        if ( isNewModule && id > 0 )
            modules.add( ml.new Module( id, type ) );

        for ( Module m : toBeRemoved )
            modules.remove( m );
    }
}
