// Creative Technology, Module 2: Smart Environments
// Final Project, Team O
// Code by Zino J. Vieth
// "HUB Server"-Application (for Raspberry PI with Java SE Runtime)
//
// "ProcessTimer"-Class
// Provices a simple timer to control Thread Execution in Program Main
//  Constructor     :   sets timer delay    :   called in program main (setup phase)
//  waitFor method  :   checks timing, resets timing checkmark  :   called in program main loop
//  updateMS        :   globally updates current milliseconds (for performance optimization)

public class ProcessTimer
{
    // ----- Global Variables -----
        static long globalMS;

    // ----- Common Variables -----
        public long delay; // in Milliseconds
        public long msCounter, msCheckmark;

    // ----- Constructor -----
    // Called in porgam main (setup)
    public ProcessTimer( int initMS )
    {
        this.delay = initMS;
    }

    // ----- Timing Method -----
    // Checks timer for need to be reset.
    // Called in program main loop.
    public boolean waitFor()
    {
        // Counts up Timer
            this.msCounter = globalMS;

        // Checks Timer Counter for reaching delay threshhold
            if ( this.msCounter >= this.msCheckmark + this.delay )
            {
                // Update checkmark to match current MS
                    this.msCheckmark = this.msCounter;

                // Fire timed process
                    return true;
            }

        return false;

    }

    // ----- MS Update Method -----
    // Used to avoid repeating System.currentTimeMillis() -> performance optimization
    static void updateMS()
    {
        globalMS = System.currentTimeMillis();
    }

}
