// Creative Technology, Module 2: Smart Environments
// Final Project, Team O
// Code by Zino J. Vieth
// "tbd"-Application (for Android)
//
// "TCPClient"-Class (public) (threadable process of main())
// Receives and transmitts data from and to the HUB via TCP.
//  !!! WIP !!!
//
// !!! TCP Port: 8790 !!!
 
import java.net.*;
import java.io.*;
import java.util.ArrayList;

public class TCPClient
{
    final static int TCP_PORT = 8790;
    static String hostName;
    static ArrayList<String> queuedInput = new ArrayList<String>();

    TCPClient( String initIP )
    {
        System.out.println( "TCPClient: Attempting to connect to the TCP Socket.");

        hostName = initIP;

        Controller.updateTCP( true );
        System.out.println( "TCPClient: Successfully connected to the TCP Socket.");
    }

    static void interpretData( String protocol, String content )
    {
        String[] data = null;
        if ( content != "" )
        {
            data = content.split("_");

            switch ( protocol )
            {
                case "MDP":     // Module Data Protocol
                    for ( int i = 0; i < data.length; i+=6 )
                    {
                        long id = Long.parseLong( data[i] );
                        int type = Integer.parseInt( data[i+1] );
                        int ledPowerOn = Integer.parseInt( data[i+2] );
                        int ledCycleState = Integer.parseInt( data[i+3] );
                        int humiditySensor = Integer.parseInt( data[i+4] );
                        int waterTankSensor = Integer.parseInt( data[i+5] );

                        ModuleList.updateModuleData( id, type, ledPowerOn, ledCycleState, humiditySensor, waterTankSensor );
                    }
            }
        } else {
            //ModuleList.updateModuleData( 0, 0, 0, 0, 0, 0 );
        }
    }

    static void transmit( String output )
    {
        try (
            Socket transmissionSocket = new Socket( hostName, TCP_PORT );
            PrintWriter out = new PrintWriter( transmissionSocket.getOutputStream(), true );
            InputStreamReader in = new InputStreamReader( transmissionSocket.getInputStream() ); 
        ) {
            out.write( output );
            System.out.println( output );

            out.flush();

            if ( output.contains("DRP") )
            {
                int byteIn = in.read();
                while ( byteIn != 0 )
                {
                    if ( byteIn == '@' )
                    {
                        String protocol = "";
                        for ( int i = 0; i < 3; i++)
                            { protocol += (char)in.read(); }

                        String content = "";
                        byteIn = in.read();
                        while ( byteIn != '#' )
                        {
                            content += (char)byteIn;
                            byteIn = in.read();
                        }
                        
                        System.out.println( protocol + ": " + content );
                        interpretData(protocol, content);
                        break;
                    }
                }
            }
        }
        catch ( IOException e )
        {
            System.out.println( "TCPClient: Attempted transmission failed." );
            System.out.println( e.getMessage() );
        }
    }

    static String constructProtocol( String protocol, String[] content )
    {
        String message =        "@";
            message +=          protocol;
        
            for ( int i = 0; i < content.length; i++ )
            {
                message +=      content[i];
                if ( i != content.length-1 )
                    message +=  "_";
            }
            
            message +=          "#";

        return message;
    }
}
