// CLASS NOT USED FOR PRESENTATION / UT VERSION, as only applicable to raspberry pi version, and unnecessary for preset/stationary demo device
//
// Creative Technology, Module 2: Smart Environments
// Final Project, Team O
// Code by Zino J. Vieth
// "HUB Server"-Application (for Raspberry PI with Java SE Runtime)
//
// "ConfigWriter"-Class (public)
// Called by SetupCommunicator Main Process Method run().
// Updates the wpa-supplicant.conf of the HUBs Raspberry Pi to automatically connect to Wifi.
// Requires Raspberry Pi to restart.
//  Constructor     :   Acts as main process of the class   :   called by SetupCommunicator.
package com.teamo.biom.hub;
// ----- Imported Libraries -----
    import java.util.Properties;    // .conf / .property Library
    import java.io.*;               // Input/Output Library

public class ConfigWriter
{
    // ----- Constructor -----
    // Updates the wpa-supplicant.conf with passed SSID and Password.
    // Called by SetupCommunicator Main Process Method run().
    public ConfigWriter(String initSSID, String initPass)
    {
        // Initialize Variables
            String configFilePath = "etc/wpa-supplicant/wpa-supplicant.conf";
            Properties property = new Properties();
            InputStream is = null;

        try {
            // Open .conf file stream
                is = new FileInputStream( configFilePath );
            
            // Load Properties Object from file stream
                property.load( is );

            // Define new Property
                String propKey = "network";
                String propValue = "{ ssid=\"" + initSSID + "\" psk=\"" + initPass + "\"}";

            // Set Property
                property.setProperty( propKey, propValue );
            // Save .conf file
                property.store( new FileOutputStream( configFilePath ), null );

            System.out.println( "ConfigWriter: Successfully updated " + configFilePath + "." );
        } catch ( FileNotFoundException e ) {
            System.out.println( "ConfigWriter: Config File has not been found." );
            System.out.println( e.getMessage() );
        } catch ( IOException e ) {
            System.out.println( "ConfigWriter: An error occured while loading or storing the Property Object." );
            System.out.println( e.getMessage() );
        }
    }
}

// Resources:
//  https://stackoverflow.com/questions/16273174/how-to-read-a-configuration-file-in-java
//  https://www.opencodez.com/java/write-config-file-in-java.htm
//  https://www.raspberrypi.org/documentation/configuration/wireless/wireless-cli.md