// CLASS IS NOT USED IN PRESENTATION / DEMO VERSION ( only applicable to raspberry pi version of BI/OM HUB )
//
// Creative Technology, Module 2: Smart Environments
// Final Project, Team O
// Code by Zino J. Vieth
// "HUB Server"-Application (for Raspberry PI with Java SE Runtime)
//
// "RuntimeTerminal"-Class (public)
// Executes terminal commands on the raspberry pi
// Available commands:
//  -   "rc wifi"   :   attempts to reconnect to the configured network
package com.teamo.biom.hub;
import java.io.*;

public class RuntimeTerminal
{

    // ----- Main Execution Method -----
    static void exec( String input )
    {
        // Initilize Variables
            String cmdString = null;
            Boolean cmdValid = true;

        // Check for valid input command and set terminal cmd line accordingly
            switch( input )
            {
                case "rc wifi":
                    cmdString = "wpa_cli -i wlan0 reconfigure";
                    break;

                default:
                    System.out.println( "RuntimeTerminal: Attempted to run invalid command \"" + input + "\"." );
                    cmdValid = false;
            }

        // If a valid command has been found, execute it.
        if ( cmdValid )
        {
            // Initialize Variables
                String tmp = null;

            try {
                // Execute command
                    Process p = Runtime.getRuntime().exec( cmdString );

                // Get and Print Cmd Output to the Terminal
                    BufferedReader br = new BufferedReader(
                                            new InputStreamReader( p.getInputStream() ) );

                    while ( (tmp = br.readLine()) != null )
                        System.out.println("[" + cmdString + " LINE]: " + tmp);

                    p.waitFor();
                    System.out.println ( "[" + cmdString + " EXIT]: " + p.exitValue() );

                // Close Process
                    p.destroy();

                System.out.println( "RuntimeTerminal: Successfully exectued \"" + cmdString +"\"." );
            } catch ( IOException e ) {
                System.out.println( "RuntimeTerminal: Could not execute \"" + cmdString + "\"" );
                System.out.println( e.getMessage() );
            } catch ( InterruptedException e ) {
                System.out.println( "RuntimeTerminal: An error occured while waiting for \"" + cmdString + "\" output." );
                System.out.println( e.getMessage() );
            }
        }
    }

}

// Resources:
//  https://www.raspberrypi.org/forums/viewtopic.php?t=214814